//----------------------------------------------------------------------
// Best viewed with tabs every 4 columns
//----------------------------------------------------------------------

import java.util.*;

/**
 * GoldSum
 * This program counts/enumerates the number of different ways to
 * distribute a given target amount of gold to some number of warriors
 * where the values of the gold bars are taken from a given set.
 *
 * If the number of solutions is sufficiently small, less than 20, the
 * program also outputs the first 20 solutions in lexicographically
 * increasing order.
 *
 */
public class GoldSum {
	/** 
	 *  Counts the number of valid solutions, and if the count is 20 or
	 *  fewer, also outputs the solutions in increasing lexicographic
	 *  order.
	 */
	private static void goldSum(int target, int nWarriors, int[] V)
	{
		/* ------------------- INSERT CODE HERE ---------------------*/
		
	}

	/** 
	 *  Summarize Input
	 */
	private static void summarizeInput(		// print input summary
			int t,							// number test case
			int target, 					// target value
			int nWarriors,						// subset size
			int[] V)						// set of values
	{
											// summarize parameters
		if (t > 1) {
			System.out.println();			// separating line between tests
		}
		System.out.println("Test case " + t);
		System.out.println(" Target sum = " + target);
		System.out.println(" Number of warriors = " + nWarriors);
		System.out.print(" V = {");			// print the set
		for (int i = 0; i < V.length; i++) {
			if (i != 0) System.out.print(", ");
			System.out.print(V[i]);
		}
		System.out.println("}");
	}
	
	/** 
	 *  Main Program
	 */
	public static void main(String[] args) throws Exception {
											// read input
		Scanner scanner = new Scanner(System.in);
		int numCases = scanner.nextInt();

		for(int t = 1; t <= numCases; t++) {
			int target = scanner.nextInt(); // target value
			int nWarriors = scanner.nextInt(); // input size of subset
			if (target <= 0 || nWarriors <= 0) {
				System.out.println("Error: Target and subset size must be positive");
				System.exit(0);
			}
			int n = scanner.nextInt();		// input number of elements in set
			if (n <= 0) {
				System.out.println("Error: Set must have at least one element");
				System.exit(0);
			}
			int[] V = new int[n];			// the set of values
			for (int i = 0; i < n; i++) {	// input values
				V[i] = scanner.nextInt();
				if (V[i] <= 0 || (i > 0 && V[i] < V[i-1])) {
					System.out.println("Error: Elements must be positive and in increasing order");
					System.exit(0);
				}
			}

			// print input summary
			summarizeInput(t, target, nWarriors, V);

			goldSum(target, nWarriors, V);	// compute and output the subsets
		}
		scanner.close();					// close input stream
	}
}
